################################################################################
# This is 'TPL/schema.tpl', a aii-custom's file
################################################################################
#
# VERSION:    1.0.0, 03/12/11 12:45
# AUTHOR:     Gabor Gombas
# MAINTAINER: Gabor Gombas
# LICENSE:    http://cern.ch/eu-datagrid/license.html
#
################################################################################
# Coding style: emulate <TAB> characters with 4 spaces, thanks!
################################################################################
unique template quattor/aii/custom/schema;

function validate_aii_custom_config_hooks = {
    foreach (hook; modlist; SELF) {
        found = false;
        foreach(i; v; modlist) {
            if (exists(v['module']) && v['module'] == "custom") {
                found = true;
                if (exists(v['packages']) && hook != "post_reboot" && hook != "post_reboot_end") {
                    # In post_install you should use AII_OSINSTALL_EXTRAPKGS
                    error("custom: package installs are only supported in the post-reboot hooks. ")
                }
            };
        };

        if (found && hook != "post_reboot" && hook != "post_reboot_end" && hook != "post_install") {
            error("custom: calling from the " + hook + " hook is not supported")
        }
    };

    true;
};

type structure_custom_config_file = {
    "contents" : string
    # TODO: add owner/permission
};

type structure_custom_command = {
    "command" : string
};

type structure_custom = {
    "module"   : string with SELF == "custom"
    # Config files to generate
    "files"    : structure_custom_config_file{}
    # Packages to install
    "packages" : string[]
    # Commands to execute
    "commands" : structure_custom_command[]
};

# vim: set expandtab ts=4 sw=4:
